<template>
  <div class="progress-wrapper">
    <div class="progress">
      <div class="line" :style="{width: percent + '%'}"></div>
    </div>
    <div class="progress__text">
      <div class="current-value">
        <span class="number">{{ total.toNumber() | formatCurrencyAmount('USD', '0') }}</span>
        <span class="text">USD</span>
      </div>
      <div class="goal-value">
        <span class="number">{{ systemSettings.ico_hardcap_by_usd | formatCurrencyAmount('USD', '0') }}</span>
        <span class="text">USD</span>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState } from 'vuex';
import BigNumber from 'bignumber.js';

export default {
  props: {
    totalToken: {
      type: Number,
      default: 0,
    }
  },
  computed: {
    ...mapState([
      'systemSettings',
    ]),
    percent () {
      const percent = this.total.dividedBy(this.systemSettings.ico_hardcap_by_usd);
      if (percent.gte(1)) {
        return 100;
      } else if (!!percent.toNumber() && percent.times(100).lte(0.3)) {
        return 0.5;
      }
      return percent.multipliedBy(100).toNumber();
    },
    total () {
      const hetaPerUsd = BigNumber(this.systemSettings.ico_price_heta_token_per_usd);
      return hetaPerUsd.times(this.totalToken);
    },
  },
};
</script>
<style lang="scss" scoped>
  @import '../../../../sass/variables';
  @import '../../../../sass/vendor/position';

  .progress-wrapper {
    max-width: 800px;
    margin: 0 auto;
  }
  
  .progress {
    border-radius: 30px;
    background-color: #463d6c;
    box-shadow: 0 0 15px 0 rgba(0, 0, 0, 0.08);
    height: 10px;
    margin: 0 auto;
  }

  .line {
    border-radius: 30px;
    background-image: linear-gradient(to right, #fad961, #f76b1c);
    box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.32);
    height: 10px;
  }

  .current-value,
  .goal-value {
    .number {
      font-size: $medium;
      font-size: 16px;
      font-weight: bold;
      color: $white;
    }

    .text {
      font-size: $small;
      color: $gray_text_dashboard
    }
  }

  .progress__text {
    padding-top: 8px;
    &:after {
      content: "";
      display: table;
      clear: both;
    }
  }

  .current-value {
    float: left;
  }

  .goal-value {
    float: right;
  }
</style>